/*----------------------------------------------------------------------------
 *  rcat.c - reverse cat
 *
 *  usage: rcat file
 *
 *  used by cgi scripts of mini httpd
 *
 *  Copyright (c) 2000-2001 Frank Meyer <frank@fli4l.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Creation:	    16.02.2001  fm
 *  Last Update:    09.09.2001  fm
 *----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

int
main (int argc, char ** argv)
{
    FILE *	fp;
    struct stat st;
    char *	filename;
    char *	buf;
    char *	p;
    int		len;
    int		ch;
    int		i;

    if (argc != 2)
    {
	fprintf (stderr, "usage: %s file\n", argv[0]);
	exit (1);
    }

    filename = argv[1];

    if (stat (filename, &st) != 0)
    {
	perror (filename);
	exit (1);
    }

    len = st.st_size;
    buf = malloc (len + 1);

    if (! buf)
    {
	perror (argv[0]);
	exit (1);
    }

    fp = fopen (filename, "r");

    if (! fp)
    {
	perror (filename);
	exit (1);
    }

    p = buf;

    for (i = 0; i < len; i++)
    {
	ch = getc (fp);

	if (ch == EOF)
	{
	    break;
	}

	*p++ = ch;
    }

    fclose (fp);

    if (p == buf)
    {
	return (0);
    }

    *p-- = '\0';

    if (*p == '\n')
    {
	*p-- = '\0';
    }

    while (p != buf)
    {
	if (*p == '\n')
	{
	    *p = '\0';
	    puts (p + 1);
	}
	p--;
    }
    puts (p);

    return (0);
}
